<?php
/**
 * $Horde: ansel/crop.php,v 1.14 2005/01/03 14:34:47 jan Exp $
 *
 * Copyright 2003-2005 Chuck Hagenbuch <chuck@horde.org>
 *
 * See the enclosed file COPYING for license information (GPL).  If you
 * did not receive this file, see http://www.fsf.org/copyleft/gpl.html.
 */

@define('ANSEL_BASE', dirname(__FILE__));
require_once ANSEL_BASE . '/lib/base.php';
require_once 'Horde/Form.php';
require_once 'Horde/Form/Renderer.php';

$gallery_id = Util::getFormData('gallery');
$image_id = Util::getFormData('image');

$page = Util::getFormData('page');
if (!isset($page)) {
    $page = 0;
}

$gallery = &$ansel_shares->getGallery($gallery_id);
if (is_a($gallery, 'PEAR_Error')) {
    $notification->push(_("Not found or error accessing gallery."), 'horde.error');
    header('Location: ' . Horde::applicationUrl('list.php', true));
    exit;
}

$actionID = Util::getFormData('actionID');
switch ($actionID) {
case 'crop':
    $x1 = (int)Util::getFormData('x1');
    $y1 = (int)Util::getFormData('y1');
    $x2 = (int)Util::getFormData('x2');
    $y2 = (int)Util::getFormData('y2');

    $image = &$ansel_shares->getImage($image_id);
    $image->crop($x1, $y1, $x2, $y2);

    $image->updateData($image->raw());

    /* Return to the image view. */
    $imageurl = Util::addParameter('view.php', 'gallery', $gallery_id);
    $imageurl = Util::addParameter($imageurl, 'image', $image_id);
    $imageurl = Util::addParameter($imageurl, 'actionID', 'view');
    $imageurl = Util::addParameter($imageurl, 'page', $page);
    header('Location: ' . Horde::applicationUrl($imageurl, true));
    exit;
    break;
}

$image_url = Ansel::getImageUrl($image_id);

$title = _("Crop Image");
Horde::addScriptFile('crop.js', 'ansel');
$notification->push("init(); document.crop.reset(); document.getElementById('or_width').value = document.getElementById('original').width;document.getElementById('or_height').value = document.getElementById('original').height;", 'javascript');
require ANSEL_TEMPLATES . '/common-header.inc';
require ANSEL_TEMPLATES . '/menu.inc';
require ANSEL_TEMPLATES . '/crop/crop.inc';
require $registry->get('templates', 'horde') . '/common-footer.inc';
