<?php

$block_name = _("Random gallery");

/**
 * Ansel's Random gallery
 *
 * $Horde: ansel/lib/Block/random_gallery.php,v 1.5 2005/01/03 14:34:48 jan Exp $
 *
 * This file provides a random Ansel gallery through the Horde_Blocks, by
 * extending the Horde_Blocks class.
 *
 * Copyright 2003-2005 Duck <duck@obla.net>
 *
 * See the enclosed file COPYING for license information (GPL). If you did not
 * receive this file, see http://www.fsf.org/copyleft/gpl.html.
 *
 * @author  Duck <Duck@obla.net>
 * @package Horde_Block
 */
class Horde_Block_ansel_random_gallery extends Horde_Block {

    var $_app = 'ansel';

    function _title()
    {
        return Horde::link(Horde::applicationUrl('list.php', true), _("Random gallery"), 'header') . _("Random gallery") . '</a>';
    }

    function _content()
    {
        @define('ANSEL_BASE', dirname(__FILE__) . '/../..');
        require ANSEL_BASE . '/lib/base.php';

        $owner = Auth::getAuth();
        $num_galleries = Ansel::countGalleries(PERMS_SHOW, $owner, DATATREE_ROOT, false);
        if (!$num_galleries) {
            return _("There are no photo galleries available.");
        }

        $gallerylist = Ansel::listGalleries(PERMS_SHOW, $owner, DATATREE_ROOT, false, rand(0, $num_galleries - 1), 1);
        $html = '<div class="dropShadow">';

        list(, $group) = each($gallerylist);
        list($galleryId, $gallery) = each($group['galleries']);

        $viewurl = Horde::applicationUrl(Util::addParameter('view.php', 'gallery', $gallery->getId()));
        $html .= Horde::link($viewurl, sprintf(_("View %s"), $gallery->get('name')));

        if ($gallery->getDefaultImage()) {
                $html .= Horde::img(Ansel::getImageUrl($gallery->getDefaultImage(), 'thumb', true), '', '', '') . '</a>';
        } else {
                $html .= Horde::img($registry->getImageDir() . '/error.png', '', '', '') . '</a>';
        }

        $html .= '</a></div>';

        return $html;
    }

}
