#!/usr/local/bin/php
<?php
/**
 * $Horde: ansel/scripts/upgrades/2003-09-07_fix_SQL_vfs_paths.php,v 1.1 2004/09/02 19:34:15 chuck Exp $
 *
 * This is a script to fix the path names if using an SQL VFS driver
 * to store images in Ansel.
 */

/**
 ** Set this to true if you want DB inserts done.
 **/
$live = false;

@define('AUTH_HANDLER', true);
@define('ANSEL_BASE', dirname(__FILE__) . '/..');
@define('HORDE_BASE', ANSEL_BASE . '/..');

// Do CLI checks and environment setup first.
require_once HORDE_BASE . '/lib/core.php';
require_once 'Horde/CLI.php';

// Make sure no one runs this from the web.
if (!Horde_CLI::runningFromCLI()) {
    exit("Must be run from the command line\n");
}

// Load the CLI environment - make sure there's no time limit, init
// some variables, etc.
Horde_CLI::init();

require_once ANSEL_BASE . '/lib/base.php';

$vfs = &VFS::singleton($conf['vfs']['type'], Horde::getDriverConfig('vfs', $conf['vfs']['type']));

if (strstr($conf['vfs']['type'], 'sql')) {
    $vfs->_connect();
    $db = &$vfs->_db;

    $data = $db->getAssoc('SELECT vfs_id, vfs_path FROM horde_vfs');
    $count = 0;
    foreach ($data as $id => $path) {
        if (substr($path, 0, 7) == '/.ansel') {
            $count++;
            if ($live) {
                $db->query('UPDATE horde_vfs SET vfs_path = ' .
                           $db->quote(substr($path, 1)) .
                           ' WHERE vfs_id = ' . $id);
            }
        }
    }

    if ($live) {
        echo $count . " row(s) updated.\n";
    } else {
        echo $count . " row(s) would have been updated.\n";
    }
}

$files = $vfs->listFolder('.ansel');
$count = 0;
foreach ($files as $file) {
    $count++;
    if ($live) {
        $vfs->rename('.ansel', $file['name'], '.horde/ansel', $file['name']);
    }
}

if ($live) {
    echo $count . " file(s) have been moved.\n";
} else {
    echo $count . " file(s) would have been moved.\n";
    echo "Didn't actually change any data. Edit this script and set \$live to true.\n";
    echo "Back up your database while you're at it.\n";
}
