#!/usr/local/bin/php
<?php
/**
 * $Horde: ansel/scripts/upgrades/2004-04-02_fix_subgallery_paths.php,v 1.1 2004/09/02 19:34:15 chuck Exp $
 *
 * This script fixes subgallery folder paths.
 *
 * Use this script to update any existing subgalleries to use '/'
 * instead of ':' in the VFS.
 */

/**
 ** Set this to true if you want DB inserts and VFS renames done.
 **/
$live = false;

@define('AUTH_HANDLER', true);
@define('ANSEL_BASE', dirname(__FILE__) . '/..');
@define('HORDE_BASE', ANSEL_BASE . '/..');

// Do CLI checks and environment setup first.
require_once HORDE_BASE . '/lib/core.php';
require_once 'Horde/CLI.php';

// Make sure no one runs this from the web.
if (!Horde_CLI::runningFromCLI()) {
    exit("Must be run from the command line\n");
}

// Load the CLI environment - make sure there's no time limit, init
// some variables, etc.
Horde_CLI::init();

require_once ANSEL_BASE . '/lib/base.php';

$vfs = &VFS::singleton($conf['vfs']['type'], Horde::getDriverConfig('vfs', $conf['vfs']['type']));
$folders = $vfs->listFolder('.horde/ansel');

if (!$live) {
    echo "The following directories would be renamed.\n\n";
}

foreach ($folders as $folder => $attributes) {
    $parts = explode(':', $folder);
    if (sizeof($parts) > 1) {
        echo "$folder -> " . str_replace(':', '/', $folder) . "\n";
        if ($live) {
            $newname = $parts[sizeof($parts) - 1];
            $newpath = '.horde/ansel/';
            foreach ($parts as $part) {
                if ($part != $newname) {
                    $newpath .= $part . '/';
                }
            }
            $vfs->rename('.horde/ansel/', $folder, $newpath, $newname);
        }
    }
}

if (!$live) {
    echo "\nset \$live = true; to actually make the changes.\n";
}
