#!/usr/bin/php -q
<?php
/**
 * $Horde: ansel/scripts/upgrades/2004-05-21_fix_exif_dates.php,v 1.1 2004/09/02 19:34:15 chuck Exp $
 *
 * This is a script to fix the value stored in the date-uploaded
 * attribute.
 */

/**
 ** Set this to true if you want DB inserts done.
 **/
$live = false;

@define('AUTH_HANDLER', true);
@define('ANSEL_BASE', dirname(__FILE__) . '/..');
@define('HORDE_BASE', ANSEL_BASE . '/..');

// Do CLI checks and environment setup first.
require_once HORDE_BASE . '/lib/core.php';
require_once 'Horde/CLI.php';

// Make sure no one runs this from the web.
if (!Horde_CLI::runningFromCLI()) {
    exit("Must be run from the command line\n");
}

// Load the CLI environment - make sure there's no time limit, init
// some variables, etc.
require_once ANSEL_BASE . '/lib/base.php';
require_once 'Horde/Share.php';

Horde_CLI::init();
$cli = &Horde_CLI::singleton();
$registry = &Registry::singleton();
$registry->pushApp('ansel', false);
$shares = &Horde_Share::singleton($registry->getApp());

$crit['AND'] = array(array('field' => 'name', 'op' => '=', 'test' => 'filename'),
                     array('field' => 'value', 'op' => '!=', 'test' => ''));

$images = &$ansel_shares->searchAllImages($crit);

$fields = array('DateTime', 'DateTimeOriginal', 'DateTimeDigitized');
$count = 0;
foreach ($images as $id => $name) {
    $image = &$ansel_shares->getImage($name);
    $count++;

    foreach ($fields as $key => $field) {
        $timeVal = $image->get($field);
        if (!empty($timeVal)) {
            if (strstr($timeVal, ":")){
                list($ymd, $hms) = split(" ", $timeVal, 2);
                list($year, $month, $day) = split(":",$ymd, 3);
                $time = "$month/$day/$year $hms";
                $timecode = strtotime($time);
            } else {
                $timecode = $timeVal;
            }
            echo "$count: $id($field) => $timeVal = " . $timecode . "\n";
            if ($live) {
                $image->set($field, $timecode, false);
            }
        }
    }

    if ($live) {
        $image->update();
    }
}

if ($live) {
    echo $count . " row(s) updated.\n";
} else {
    echo $count . " row(s) would have been updated.\n";
}
