#!/usr/local/bin/php
<?php
/**
 * $Horde: ansel/scripts/upgrades/2004-05-25_hash_image_paths.php,v 1.3 2004/12/07 19:26:17 chuck Exp $
 *
 * This script converts the old ansel VFS storage to the new
 * hashed storage format.
 *
 * !!! IMPORTANT!!! Make sure you run this script with a user that has
 * write-access to your VFS.  It would probably be a good idea to
 * back-up your database first, too...just in case.
 */

/**
 ** Set this to true if you want DB inserts and VFS renames done.
 **/
$live = false;

@define('AUTH_HANDLER', true);
@define('ANSEL_BASE', dirname(__FILE__) . '/..');
@define('HORDE_BASE', ANSEL_BASE . '/..');

// Do CLI checks and environment setup first.
require_once HORDE_BASE . '/lib/core.php';
require_once 'Horde/CLI.php';

// Make sure no one runs this from the web.
if (!Horde_CLI::runningFromCLI()) {
    exit("Must be run from the command line\n");
}

// Load the CLI environment - make sure there's no time limit, init
// some variables, etc.
Horde_CLI::init();

require_once ANSEL_BASE . '/lib/base.php';

$vfs = &VFS::singleton($conf['vfs']['type'], Horde::getDriverConfig('vfs', $conf['vfs']['type']));

$driver = $conf['datatree']['driver'];
$datatree = &DataTree::singleton($driver, array_merge(Horde::getDriverConfig('datatree', $driver),
                                                      array('group' => 'horde.shares.ansel')));

echo 'getting image list...';
$images = $datatree->get(DATATREE_FORMAT_FLAT, DATATREE_ROOT, true);
echo "done\n";

foreach ($images as $imageId => $imageName) {
    $image = &$ansel_shares->getImage($imageName);
    if ($imageId == DATATREE_ROOT ||
        !is_a($image, 'DataTreeObject_Image') ||
        $image->get('type') == '1') {
        continue;
    }

    $oldvfspath = '.horde/ansel/' . str_replace(':', '/', $image->get('gallery'));
    $newvfspath = $image->vfspath();

    echo $oldvfspath . '/' . $image->getId() . '_full -> ' . $newvfspath . '/' . $image->getId();

    if ($live) {
        echo "...";
        $path = substr($newvfspath, 0, strrpos($newvfspath, '/'));
        $vfs->createFolder(substr($path, 0, strrpos($path, '/')), substr($path, strrpos($path, '/') + 1));
        $vfs->createFolder($path, substr($newvfspath, strrpos($newvfspath, '/') + 1));
        $vfs->rename($oldvfspath, $image->getId() . '_full', $newvfspath, $image->getId());
        $vfs->deleteFile($oldvfspath, $image->getId() . '_thumb');
        $vfs->deleteFile($oldvfspath, $image->getId() . '_screen');
        $vfs->deleteFolder(substr($oldvfspath, 0, strrpos($oldvfspath, '/')), substr($oldvfspath, strrpos($oldvfspath, '/') + 1));
        echo "ok";
    }

    echo "\n";
}

if (!$live) {
    echo "\nset \$live = true; to actually make the changes.\n";
} else {
    echo "\n\nMake sure to check the permissions on the vfs files\n";
    echo "and directories.\n";
}
