<?php
Horde::addScriptFile('popup.js', 'horde', true);
$addurl = Util::addParameter('image.php', 'gallery', $galleryId);
$captionurl = Util::addParameter('captions.php', 'gallery', $galleryId);
$galleryurl = Util::addParameter('gallery.php', 'gallery', $galleryId);
$viewurl = Util::addParameter('view.php', 'gallery', $galleryId);
$reorderurl = Util::addParameter('reorder.php', 'gallery', $galleryId);

$galleries = Ansel::selectGalleries(Ansel::listGalleries(PERMS_EDIT));
$option_copy = !empty($galleries);
$option_edit = $gallery->hasPermission(Auth::getAuth(), PERMS_EDIT);
$option_delete = $gallery->hasPermission(Auth::getAuth(), PERMS_DELETE);
$option_select = $option_copy || $option_delete;

$min = $page * $perpage;
$max = $min + $perpage;
if ($max > $numimages) {
    $max = $numimages;
}

$nav_id = 0;

if ($option_select && $numimages): ?>
<script language="Javascript" type="text/javascript">
<!--
var loading;

function selectAll()
{
    for (i = 0; i < document.gallery.elements.length; i++) {
        document.gallery.elements[i].checked = true;
    }
}

function selectNone()
{
    for (i = 0; i < document.gallery.elements.length; i++) {
        document.gallery.elements[i].checked = false;
    }
}

function deleteSelected()
{
    if (loading == null && confirm('<?php echo _("Are you sure you want to delete the selected images?") ?>')) {
        loading = true;
        document.gallery.actionID.value = 'delete';
        document.gallery.submit();
    }
}

function copySelected()
{
    if (loading == null) {
        loading = true;
        document.gallery.actionID.value = 'copy';
        document.gallery.submit();
    }
}

function moveSelected()
{
    if (loading == null) {
        loading = true;
        document.gallery.actionID.value = 'move';
        document.gallery.submit();
    }
}
//-->
</script>
<form name="gallery" action="<?php echo Horde::applicationURL('image.php'); ?>" method="get">
<input type="hidden" name="actionID" value="" />
<input type="hidden" name="gallery" value="<?php echo $gallery->getId(); ?>" />
<input type="hidden" name="page" value="<?php echo $page; ?>" />
<?php echo Util::formInput() ?>
<?php endif; ?>

<div class="header">
<?php echo '<span style="float:right">' . sprintf(_("Displaying from %s to %s of %s images"), $pagestart, $pageend, $numimages) . '</span>' . $title; ?>
<?php if (!$print_view) { echo Horde::link(Horde::applicationUrl(Util::addParameter($viewurl, 'page', $page)), _("Refresh List")) . '&nbsp' . Horde::img('reload.png', _("Refresh Gallery View"), null, $registry->getImageDir('horde')) . '</a>&nbsp;'; } ?>
</div>

<?php if ($gallery->get('desc')): ?>
<div class="control">
<?php echo Text_Filter::filter($gallery->get('desc'), 'text2html', array('parselevel' => TEXT_HTML_MICRO)) ?>
</div>
<?php endif; ?>

<div class="control">
  <?php if (!$print_view): ?>
    <?php if ($option_edit): ?>
      <?php echo Horde::link(Horde::applicationUrl(Util::addParameter($addurl, 'actionID', 'add')), _("Upload"), 'widget') . _("Upload") ?></a>
      | <?php echo Horde::link(Horde::applicationUrl(Util::addParameter($galleryurl, 'actionID', 'addchild')), _("Add Subgallery"), 'widget') . _("Subgallery") ?></a>
      | <?php echo Horde::link(Horde::applicationUrl(Util::addParameter($galleryurl, 'actionID', 'modify')), _("Modify Gallery"), 'widget') . _("Modify") ?></a>
      | <?php echo Horde::link(Horde::applicationUrl($captionurl), _("Caption Editor"), 'widget') . _("Captions") ?></a>
      | <?php echo Horde::link(Horde::applicationUrl(Util::addParameter($reorderurl, 'actionId' , 'getOrder')), _("Reorder Gallery"), 'widget') . _("Reorder") ?></a>
    <?php endif; ?>
    <?php if ($gallery->get('owner') == Auth::getAuth()): ?>
      | <?php echo Horde::link('', _("Set Permissions"), 'widget', '', 'popup(\'' . str_replace('&amp;', '&', Util::addParameter(Horde::applicationUrl('perms.php'), 'share', $gallery->getName())) . '\'); return false;') . _("Permissions") ?></a>
    <?php endif; ?>
    <?php if ($option_delete): ?>
      | <?php echo Horde::link(Horde::applicationUrl(Util::addParameter($galleryurl, 'actionID', 'delete')), _("Delete Gallery"), 'widget', '', 'return window.confirm(\'' . addslashes(_("Are you sure you want to delete this gallery? All images in it will be deleted.")) . '\');') . _("Delete") ?></a>
    <?php endif; ?>
  <?php endif; ?>
</div>

<?php if ($option_select && $numimages) include ANSEL_TEMPLATES . '/view/navbar-gallery.inc' ?>

<?php
if (!$numimages) {
    echo '<em>' . _("There are no images in this gallery.") . '</em>';
} else {
    echo '<div style="clear:both" align="center">' . $pager->render() . '</div>';

    $imagesperrow = $prefs->getValue('imagesperrow');
    $cellwidth = round(100 / $imagesperrow);
    $count = 0;
    $total = $min;

    echo '<table border="0" width="100%"><tr>';

    foreach ($imagelist as $id => $name) {
        if ($total++ < $min || $total > $max) {
            continue;
        }

        $image = &$ansel_shares->getImage($id);

        echo '<td width="' . $cellwidth . '%" valign="top">';
        echo '<div class="dropShadow">';

        $image_url = Util::addParameter($addurl, array('image' => $id, 'page' => $page));
        $view_url = Util::addParameter($viewurl, array('image' => $id, 'actionID' => 'viewimage', 'page' => $page));
        $crop_url = Util::addParameter('crop.php', array('gallery' => $galleryId, 'image' => $id, 'page' => $page));

        $thumb_url = Ansel::getImageUrl($id, 'thumb');

        echo Horde::link(Horde::applicationUrl($view_url), $image->get('filename'));
        echo Horde::img($thumb_url, '', '', '') . '</a>';
        echo '</div>';

        $description = $image->get('description');
        if (!empty($description)) {
            require_once 'Horde/Text/Filter.php';
            echo '<div style="clear:both">' . Text_Filter::filter($description, 'text2html', array('parselevel' => TEXT_HTML_MICRO)) . '</div>';
        }

        if (!$print_view && $option_select) { ?>
  <div style="clear:both">
    <span class="item">
    <?php if ($option_select): ?>
      <input type="checkbox" name="image[<?php echo $id ?>]" />
    <?php endif; ?>
    <?php if ($option_edit): ?>
      <?php echo Horde::link('', _("Properties"), 'widget', '', 'popup(\'' . str_replace('&amp;', '&', Util::addParameter(Horde::applicationUrl(Util::addParameter($image_url, 'actionID', 'modify')), 'share', $gallery->getName())) . '\', 600, 220); return false;') . _("Properties") ?></a>
      | <?php echo Horde::link(Horde::applicationUrl(Util::addParameter($image_url, 'actionID', 'editimage')), _("Edit"), 'widget') . _("Edit") ?></a>
      <?php if (Ansel::isAvailable('crop')): ?>
      | <?php echo Horde::link(Horde::applicationUrl($crop_url), _("Crop"), 'widget') . _("Crop") ?></a>
      <?php endif; ?>
    <?php endif; ?>
    </span>
  </div>
<?php
        }

        echo '</td>';
        if (!(++$count % $imagesperrow)) {
            echo '</tr><tr>';
        }
    }

    while ($count++ % $imagesperrow) {
        echo '<td>&nbsp;</td>';
    }

    echo '</tr></table>';

    echo '<div style="clear:both" align="center">' . $pager->render() . '</div>';
}
?>
</form>
